with Unchecked_Deallocation;

package body Contenedores.rboles_Binarios is
	--------------------------
	-- Operaciones Internas --
	--------------------------	
	procedure Insertar(A: in out rbol_Bin_Bus; E: in TElemento) is
	begin
		if A = null then
			-- El nuevo valor se inserta como hoja
			A := new Nodo_Binario'(E, (null, null));
		else
			-- Si E = A.Clave, no se inserta
			if E /= A.Clave then
				-- La insercin contina en el subrbol adecuado
				if E < A.Clave then
					Insertar(A.Hijos(1), E);
				else
					Insertar(A.Hijos(2), E);
				end if;
			end if;
		end if;
	end Insertar;

	procedure Extraer(A: in out rbol_Bin_Bus; E: in TElemento) is
		function Sucesor_Simtrico(A: rbol_Bin_Bus) return rbol_Bin_Bus is
			--...
		begin
			--...
			return null; -- ESTA IMPLEMENTACIN SE DEJA COMO EJERCICIO
			--------------------------------------------------------------
			-- El sucesor de un nodo de grado 2 es el primer nodo hacia --  
			-- la izquierda, a partir del hijo derecho, que no tenga    --
			-- hijo izquierdo                                           --
			-- El sucesor adopta a los hijos del nodo a extraer y el    --
			-- hijo derecho del sucesor es adoptado por el padre del    --
			-- sucesor (salvo que el sucesor sea el hijo derecho del    --
			-- nodo a extraer)                                          --
			--------------------------------------------------------------
		end Sucesor_Simtrico;
		
		Sustituto: rbol_Bin_Bus;
	begin
		if A /= null then
			-- Si E /= A.Clave, la extraccin se producir en
			-- el subrbol que corresponda
 	    	if E < A.Clave then
				Extraer(A.Hijos(1), E);
			else
				if A.Clave < E then
					Extraer(A.Hijos(2), E);
				else
					-- Se ha encontrado el nodo a extraer
					-- Tiene grado 0  1?
					if A.Hijos(1) = null then
						Sustituto := A.Hijos(2);
					else
						if A.Hijos(2) = null then
							Sustituto := A.Hijos(1);
						else
							-- Tiene grado 2, hay que buscar su sucesor
							-- en simtrico
							Sustituto := Sucesor_Simtrico(A);
						end if;
					end if;

					-- Se elimina el nodo, cambindolo por el sustitudo
					-- adecuado
					Eliminar(A);
					A := Sustituto;
				end if;
			end if;
		end if;
	end Extraer;

	function Buscar(A: rbol_Bin_Bus; E: TElemento)
			return  rbol_Bin_Bus is
	begin
			-- ...
			retuRn null; --ESTO NO ES
	end Buscar;

	procedure Vaciar(A: in out rbol_Bin_Bus) is
	begin
			--...
			NULL;
	end Vaciar;

	function Tamao(A: rbol_Bin_Bus) return Natural is
	begin
			--...
			RETURN 0; --ESTO NO ES
	end tamao;

	-------------------------------
	-- Operaciones constructoras --
	-------------------------------	
	procedure Insertar(C: in out Binario_Bsqueda; E: in TElemento) is
	begin
		Insertar(C.Elementos, E); -- Se llama a la operacin del
		                          -- rbol binario de bsqueda
	end;

	procedure Extraer(C: in out Binario_Bsqueda; E: in TElemento) is
	begin
		Extraer(C.Elementos, E); -- Se llama a la operacin del
		                         -- rbol binario de bsqueda

	end;

	procedure Vaciar(C: in out Binario_Bsqueda) is
	begin
		Vaciar(C.Elementos); -- Se llama a la operacin del
		                     -- rbol binario de bsqueda

	end;

	------------------------------
	-- Operaciones observadoras --
	------------------------------
	function Est(C: in Binario_Bsqueda; E: in TElemento) return Boolean is
	begin
		-- Se llama a la operacin del rbol binario de bsqueda
		return Buscar(C.Elementos, E) /= null; 
	end;

	function Tamao(C: in Binario_Bsqueda) return Natural is
	begin
		return Tamao(C.Elementos); -- Se llama a la operacin del
		                            -- rbol binario de bsqueda
	end;
end Contenedores.rboles_Binarios;
