generic
package Contenedores.rboles_Binarios.Ajustables.Biselados is
	-- Tipo contenedor implementado con un rbol binario de bsqueda.
	type Biselado is new Binario_bsqueda with private;
		-- Los contenedores se crean vacos.

	-------------------------------
	-- Operaciones constructoras --
	-------------------------------	
	procedure Insertar(C: in out Biselado; E: in TElemento);
		-- Aade el elemento E al contenedor C, si no est ya presente.
		-- Si E est en C no hace nada.
		-- Si cuando se va a realizar la insercin no hay espacio,
		-- se lanza la excepcin Contenedor_Lleno.

	procedure Extraer(C: in out Biselado; E: in TElemento);
		-- Se quita el elemento E del contendor C. Si E no est en C,
		-- no hace nada.

	procedure Vaciar(C: in out Biselado);
		-- Vaca el contenedor C, dejndolo sin elementos.

	------------------------------
	-- Operaciones observadoras --
	------------------------------
	procedure Est(C: in out Biselado; E: in TElemento; Encontrado : out Boolean);
		-- Devuelve Encontrado = True si el elemento E est en el contendor C
		-- y False si no.

	function Tamao(C: in Biselado) return Natural;
		-- Devuelve el nmero de elementos del contenedor C.

	function Raz(C: in Biselado) return TElemento;

private
	type Biselado is new Binario_bsqueda with null record;
end Contenedores.rboles_Binarios.Ajustables.Biselados;
