package rbolesBinariosBsqueda;

public class rbolBinarioAjustable extends rbolBinarioBsqueda {
	/**
	 * Clase interna auxiliar
	 */
	protected class BooleanoMutable {
		boolean lgico;
		public BooleanoMutable() {
			lgico = false;
		}
		public boolean valorLgico() {
			return lgico;
		}
		public void ponerFalso() {
			lgico = false;
		}
		public void ponerVerdadero() {
			lgico = true;
		}
	}

	public rbolBinarioAjustable() {
		super();
	}

	protected NodoBinario rotacinSimple(NodoBinario nodo, int rama) {
		//Se intercambian los nodos
		NodoBinario hijo = nodo.enlaces[rama];
		int otraRama = 1 - rama;
		nodo.enlaces[rama] = hijo.enlaces[otraRama];
		hijo.enlaces[otraRama] = nodo;
		return hijo;
	}

	protected NodoBinario rotacinDoble(NodoBinario nodo, int rama) {
		//Se intercambian los nodos
		NodoBinario hijo = nodo.enlaces[rama];
		int otraRama = 1 - rama;
		NodoBinario nieto = hijo.enlaces[otraRama];
		nodo.enlaces[rama] = nieto.enlaces[otraRama];
		hijo.enlaces[otraRama] = nieto.enlaces[rama];
		nieto.enlaces[otraRama] = nodo;
		nieto.enlaces[rama] = hijo;
		return nieto;
	}

	protected NodoBinario rotacinDobleInversora(
			NodoBinario nodo, int rama) {
		//Se intercambian los nodos
		NodoBinario hijo = nodo.enlaces[rama];
		int otraRama = 1 - rama;
		NodoBinario nieto = hijo.enlaces[rama];
		nodo.enlaces[rama] = hijo.enlaces[otraRama];
		hijo.enlaces[rama] = nieto.enlaces[otraRama];
		nieto.enlaces[otraRama] = hijo;
		hijo.enlaces[otraRama] = nodo;
		return nieto;
	}
}
